package Triggers;

use strict;
use warnings;

our @trigger_data;
require "triggerlist.pl";

# create { name => [ 'type' name, { param name => nice param name } ] } hashes

our %ops_to_text = ('<', 'Less', '<=', 'LessEqual', '==', 'Equal', '>=', 'GreaterEqual', '>', 'Greater');
our %ops_from_text = reverse %ops_to_text;

our @yesno_to_text = qw(No Yes);
our %yesno_from_text = (No => 0, Yes => 1);

our @priorities_to_text = qw(Low MedLow Medium MedHigh High);
our %priorities_from_text = (Low=>0, MedLow=>1, Medium=>2, MedHigh=>3, High=>4);

our @techstatuses_to_text = qw(Unobtainable Obtainable Available Researching Active Persistent   Active); # -1 maps to Active
our %techstatuses_from_text = (Unobtainable=>0, Obtainable=>1, Available=>2, Researching=>3, Active=>4, Persistent=>5);

our %vartype_from_text = (
  long       => 0,
  string     => 1,
  float      => 2,
  bool       => 3,
  unit       => 4,
  area       => 5,
  player     => 6,
  sound      => 7,
  event      => 8,
  camtrack   => 9,
  tech       => 10,
  techstatus => 11,
  godpower   => 12,
  protounit  => 13,
  resource   => 14,
  operator   => 15,
  alliance   => 16,
  group      => 17,
  camerainfo => 18,
  unitstance => 19,
  uicategory => 20,
  # ???????? => 21,
  stringid   => 22,
);


# for my $x (0,1) { for my $t (0..@{$trigger_data[$x]}/2-1) {
#   foreach (@{$trigger_data[$x][$t*2+1][1]}) {
#     print "** $_->[3]\n" unless exists $vartype_from_text{$_->[3]};
#   }
# }}


our %condition_to_text;
for my $t (0..@{$trigger_data[0]}/2-1) {
  $condition_to_text{$trigger_data[0][$t*2]} = [ # internal name
    $trigger_data[0][$t*2+1][0], { # nice name
      map @$_[0,1], # param internal/nice names
        @{$trigger_data[0][$t*2+1][1]}
    }
  ];
}

our %effect_to_text;
for my $t (0..@{$trigger_data[1]}/2-1) {
  $effect_to_text{$trigger_data[1][$t*2]} = [ # internal name
    $trigger_data[1][$t*2+1][0], { # nice name
      map @$_[0,1], # param internal/nice names
        @{$trigger_data[1][$t*2+1][1]}
    }
  ];
}

our %condition_from_text;
for my $t (0..@{$trigger_data[0]}/2-1) {
  $condition_from_text{$trigger_data[0][$t*2+1][0]} = # nice name
    [$trigger_data[0][$t*2], # actual name
     $trigger_data[0][$t*2+1]]; # array ref to all the data
}

our %effect_from_text;
for my $t (0..@{$trigger_data[1]}/2-1) {
  $effect_from_text{$trigger_data[1][$t*2+1][0]} = # nice name
    [$trigger_data[1][$t*2], # actual name
     $trigger_data[1][$t*2+1]]; # array ref to all the data
}

1;
